var ssOptions = null;

function ssOptionsLoad() 
{
  ssOptions = new ssOptionsManager();
  ssOptions.init();
}

function ssOptionsUnload()
{
  ssOptions.destroy();
  ssOptions = null;
}

function ssOptionsManager()
{
  return this;
}

ssOptionsManager.prototype =
{
  init: function()
  {
    var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService( Components.interfaces.nsIPrefService );
    var branch = preferencesService.getBranch( "extensions.purplebunny." );
    
  	this.barinput = document.getElementById( "barinput" );
  	//this.neighborinput = document.getElementById( "neighborinput" );
  	this.aligninput = document.getElementById( "aligninput" );
  	
  	this.populateBars();
  	
  	var bar;
  	if( !branch.prefHasUserValue( "purplebunny.bar" ) )
  	{
  		var items = this.barinput.firstChild.childNodes;
  		bar = items[0].getAttribute( "id" );
  		branch.setCharPref( "purplebunny.bar", bar );
  	}
  	bar = branch.getCharPref( "purplebunny.bar" );
  	this.barinput.selectedItem = document.getElementById( bar );
  	
  	this.populateNodes();
  	
/*
  	var nextnode;
  	if( !branch.prefHasUserValue( "purplebunny.nextnode" ) )
  	{
  		var items = this.neighborinput.firstChild.childNodes;
  		nextnode = items[0].getAttribute( "id" );
  		branch.setCharPref( "purplebunny.nextnode", nextnode );
  	}
  	nextnode = branch.getCharPref( "purplebunny.nextnode" );
  	this.neighborinput.selectedItem = document.getElementById( nextnode );
  	
*/
  	var insertafter;
  	if( !branch.prefHasUserValue( "purplebunny.insertafter" ) )
  	{
  		insertafter = false;
  		branch.setBoolPref( "purplebunny.insertafter", insertafter );
  	}
  	insertafter = branch.getBoolPref( "purplebunny.insertafter" );
  	this.aligninput.selectedItem = document.getElementById( insertafter ? "insertright" : "insertleft" );
  	
  },

  destroy: function()
  {
    
  },
  
  populateBars: function()
  {      
   	// Creates the menuitems for the toolbar selector.
    var topWindow = getTopWindow();
    var toolbars = topWindow.document.getElementsByTagName( "toolbar" );
    var statusbars = topWindow.document.getElementsByTagName( "statusbar" );
    var pnode = document.getElementById( "ssbarpopup" );
    var bar_id, newitem;
          
    toolbars = concat( toolbars, statusbars );
    for( var x = 0; x < toolbars.length; x++ ) 
    {
      bar_id = toolbars[x].getAttribute( "id" );
      //do not include find toolbar
      if( bar_id == "pbbar" )
      {
        continue;      	
      }
      
      newitem = document.createElement( "menuitem" );
      newitem.setAttribute( "id", bar_id );
      newitem.setAttribute( "label", bar_id );
      pnode.appendChild( newitem );
    }
  },

  populateNodes: function()
  {
/*
    // Creates the menuitems for the nextnode selector.
    var topWindow = getTopWindow();	      
    var pnode = document.getElementById( "neighborinputpopup" );
    var nodes = pnode.childNodes;
    var bar_id = this.barinput.selectedItem.getAttribute( "id" );
    var node_id, newitem, x;
  
    // Remove all the menuitems currently in the popup.
    for( x = 0; x < nodes.length; x++ )
    {
      pnode.removeChild(nodes[x]);
    }
  
    nodes = topWindow.document.getElementById( bar_id ).childNodes;
    for( x = 0; x < nodes.length; x++ ) 
    {
      node_id = nodes[x].getAttribute( "id" );
  
      // Don't include the pbbar or generated content in the list.
      if (node_id == "pbbar" || nodes[x].tagName == "toolbarspacer" || 
        nodes[x].tagName == "toolbarseparator" || nodes[x].tagName == "toolbarspring")
      { 
        continue;
      }
      newitem = document.createElement( "menuitem" );
      newitem.setAttribute( "id", node_id );
      newitem.setAttribute( "label", node_id );
      pnode.appendChild( newitem );
    }
  
    // And finally select the first one in the list.
    pnode.parentNode.selectedItem = pnode.firstChild;
   */
  },

  accept: function()
  {
    var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService( Components.interfaces.nsIPrefService );
    var branch = preferencesService.getBranch( "extensions.purplebunny." );  	
  	
    branch.setCharPref( "purplebunny.bar", this.barinput.selectedItem.getAttribute( "id" ) );
    //branch.setCharPref( "purplebunny.nextnode", this.neighborinput.selectedItem.getAttribute( "id" ) );
    branch.setBoolPref( "purplebunny.insertafter", this.aligninput.selectedItem.getAttribute( "id" ) == "insertright" );
    
    moveBox( branch );
  
  },
};


function moveBox( branch )
{
	var topWindow = getTopWindow();
	
	if( !branch.prefHasUserValue( "purplebunny.bar" ) || !branch.prefHasUserValue( "purplebunny.insertafter" ) )
	{
		return;
	}
	
  //check if box is in the right location
  var toolbar = topWindow.document.getElementById( branch.getCharPref( "purplebunny.bar" ) );
  //var nextnode = topWindow.document.getElementById( branch.getCharPref( "purplebunny.nextnode" ) );
  var insertafter = branch.getBoolPref( "purplebunny.insertafter" );
  var ssbar	= topWindow.document.getElementById( "pbbar" );
    
  // bail if it is in the right place or the prefs are not in sync
  /*
var neighbor = ( (insertafter) ? nextnode.nextSibling : nextnode.previousSibling );
  if( neighbor )
  {
    neighbor = neighbor.getAttribute( "id" );
  }

  if( ( ( neighbor == "pbbar" ) && ( ssbar.parentNode == toolbar ) ) || ( nextnode.parentNode != toolbar ) ) 
  {
    return;
  }
*/
  
  //remove us from parent
  ssbar.parentNode.removeChild(ssbar);

	var children = toolbar.childNodes;

	if ((children.length == 0) || (insertafter))
		toolbar.appendChild(ssbar);
	else
		toolbar.insertBefore(ssbar, children[0]);


/*
  //place box
  if( insertafter ) 
  {
    var next_node = nextnode.nextSibling;
    if( next_node )
    {
      toolbar.insertBefore( ssbar, next_node );
    }
    else
    {
      toolbar.appendChild( ssbar );
    }
  }
  else
  {
    toolbar.insertBefore( ssbar, nextnode );
  }
*/
}

function getTopWindow()
{
  var windowManager = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService();
  var windowManagerInterface = windowManager.QueryInterface( Components.interfaces.nsIWindowMediator );
  var topWindow = windowManagerInterface.getMostRecentWindow( "navigator:browser" );
  if( !topWindow )
  {
    topWindow = window.openDialog("chrome://browser/content/browser.xul", "_blank", "chrome,all,dialog=no", "about:blank", null, null);
  }

  return topWindow;
}

function concat( c1, c2 )
{
  // Concats too collections into an array.
  var c3 = new Array( c1.length + c2.length );
  var x,y = 0;

  for( x = 0; x < c1.length; x++ )
  {
    c3[y++] = c1[x];
  }

  for( x = 0; x < c2.length; x++ )
  {
    c3[y++] = c2[x];
  }

  return c3;
}
